Bug 1335029 - set errno in case of inode_link failures
Summary: set errno in case of inode_link failures
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: libgfapi
Version: rhgs-3.1
Hardware: All
OS: All
unspecified
medium
Target Milestone: ---
: RHGS 3.2.0
Assignee: Soumya Koduri
QA Contact: Arthy Loganathan
URL:
Whiteboard:
Depends On: 1334621 1334854
Blocks: 1333546 1351515
TreeView+ depends on / blocked
 
Reported: 2016-05-11 07:52 UTC by Soumya Koduri
Modified: 2017-03-23 05:30 UTC (History)
7 users (show)

Fixed In Version: glusterfs-3.8.4-1
Doc Type: Bug Fix
Doc Text:
Clone Of: 1334621
Environment:
Last Closed: 2017-03-23 05:30:40 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:0486 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.2.0 security, bug fix, and enhancement update 2017-03-23 09:18:45 UTC

Description Soumya Koduri 2016-05-11 07:52:03 UTC
+++ This bug was initially created as a clone of Bug #1334621 +++

Description of problem:

Currently gfapi does not seem to be setting errno appropriately in case of inode_link failures. This may cause mislead applications (for eg., nfs-ganesha) which rely on errno to determine the error encountered. 


Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

--- Additional comment from Vijay Bellur on 2016-05-10 03:44:07 EDT ---

REVIEW: http://review.gluster.org/14278 (gfapi: set errno for inode_link failures) posted (#1) for review on master by soumya k (skoduri@redhat.com)

--- Additional comment from Vijay Bellur on 2016-05-10 06:08:26 EDT ---

REVIEW: http://review.gluster.org/14278 (libglusterfs/gfapi: set appropriate errno for inode_link failures) posted (#2) for review on master by soumya k (skoduri@redhat.com)

--- Additional comment from Vijay Bellur on 2016-05-10 07:42:01 EDT ---

REVIEW: http://review.gluster.org/14278 (libglusterfs/gfapi: set appropriate errno for inode_link failures) posted (#3) for review on master by soumya k (skoduri@redhat.com)

--- Additional comment from Vijay Bellur on 2016-05-10 12:10:28 EDT ---

COMMIT: http://review.gluster.org/14278 committed in master by Niels de Vos (ndevos@redhat.com) 
------
commit 176724cdec7061ead0bd7497bb56d0ac09a668a7
Author: Soumya Koduri <skoduri@redhat.com>
Date:   Tue May 10 13:03:42 2016 +0530

    libglusterfs/gfapi: set appropriate errno for inode_link failures
    
    We do not seem to be setting errno appropriately in case
    of inode_link failures. This errno may be used by any application
    (for eg., nfs-ganesha) to determine the error encountered. This
    patch addresses the same.
    
    Change-Id: I674f747c73369d0597a9c463e6ea4c85b9091355
    BUG: 1334621
    Signed-off-by: Soumya Koduri <skoduri@redhat.com>
    Reviewed-on: http://review.gluster.org/14278
    Smoke: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Niels de Vos <ndevos@redhat.com>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    Reviewed-by: jiffin tony Thottan <jthottan@redhat.com>
    Reviewed-by: Kaleb KEITHLEY <kkeithle@redhat.com>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.com>

Comment 2 Soumya Koduri 2016-05-11 07:54:52 UTC
The issue was uncovered with bug1333546. The fixes are posted/merged upstream -
http://review.gluster.org/#/c/14278
https://review.gerrithub.io/275930

Comment 4 Atin Mukherjee 2016-09-17 12:03:09 UTC
Upstream mainline : http://review.gluster.org/14278
Upstream 3.8 : http://review.gluster.org/14288

And the fix is available in rhgs-3.2.0 as part of rebase to GlusterFS 3.8.4.

Comment 7 Arthy Loganathan 2016-12-29 05:36:43 UTC
Verified the fix in build,

nfs-ganesha-gluster-2.4.1-3.el7rhgs.x86_64
glusterfs-ganesha-3.8.4-10.el7rhgs.x86_64
nfs-ganesha-2.4.1-3.el7rhgs.x86_64

Basic IO's are running fine and no crashes are observed.

Comment 9 errata-xmlrpc 2017-03-23 05:30:40 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0486.html


Note You need to log in before you can comment on or make changes to this bug.